VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "TMenu"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'Local variables
Private m_MenuHwnd As Long
Private m_MenuID As Long
Private m_Caption As String
Private m_Picture As Object
Private m_DIS As DRAWITEMSTRUCT

Public hwndOwner As Long

'API declarations
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Private Declare Function FillRect Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long
Private Declare Function MoveToEx Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, lpPoint As Long) As Long
Private Declare Function LineTo Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long
Private Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Private Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Private Declare Function SetBkMode Lib "gdi32" (ByVal hdc As Long, ByVal nBkMode As Long) As Long
Private Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal lpString As String, ByVal nCount As Long) As Long
Private Declare Function GetTextColor Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function SetTextColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Private Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hdc As Long) As Long

'API Constants
Private Const SRCCOPY = &HCC0020
Private Const PS_SOLID = 0
Private Const COLOR_MENU = 4
Private Const COLOR_MENUTEXT = 7
Private Const COLOR_HIGHLIGHT = 13
Private Const COLOR_HIGHLIGHTTEXT = 14
Private Const ODS_SELECTED = &H1
Private Const NEWTRANSPARENT = 3

Public Property Let Caption(sCaption As String)
  m_Caption = sCaption
End Property

Public Property Get Caption() As String
  Caption = m_Caption
End Property

Public Sub InitMenu(hMenuID As Long, sCaption As String, objPicture As Object)
  m_MenuID = hMenuID
  m_Caption = sCaption
  Set m_Picture = objPicture
End Sub

Public Sub InitDIS(hdc As Long, nAction As Long, nID As Long, nState As Long, nLeft As Long, nTop As Long, nBottom As Long, nRight As Long)
  m_DIS.hdc = hdc
  m_DIS.itemAction = nAction
  m_DIS.itemID = nID
  m_DIS.itemState = nState
  m_DIS.rcItem.Left = nLeft
  m_DIS.rcItem.Top = nTop
  m_DIS.rcItem.Bottom = nBottom
  m_DIS.rcItem.Right = nRight
End Sub

Public Property Get MenuID() As Long
   MenuID = m_MenuID
End Property

Private Sub PrintTrans(clr As Long)
  SetBkMode m_DIS.hdc, NEWTRANSPARENT
  Dim crOldType As Long
  crOldType = GetTextColor(m_DIS.hdc)
  SetTextColor m_DIS.hdc, clr
  TextOut m_DIS.hdc, mnuPicWidth + mnuTextBuffer, m_DIS.rcItem.Top + 2, m_Caption, Len(m_Caption)
  SetTextColor m_DIS.hdc, crOldType
End Sub

Public Sub DrawMenu()
'Init Struct
  Dim DIS As DRAWITEMSTRUCT
  DIS = m_DIS
'Draw menu entry
  Dim hSelectedItem As Long, crSelected As Long
  Dim hMenuColor As Long
  hSelectedItem = CreateSolidBrush(GetSysColor(COLOR_HIGHLIGHT))
  crSelected = GetSysColor(COLOR_HIGHLIGHTTEXT)
  hMenuColor = CreateSolidBrush(GetSysColor(COLOR_MENU))
  Dim rct As RECT
  rct = m_DIS.rcItem
  If mnuPicWidth <= 0 Then mnuPicWidth = 24
  If mnuTextBuffer <= 0 Then mnuTextBuffer = 5
  If mnuEdgeWidth <= 0 Then mnuEdgeWidth = 1
  rct.Left = (mnuPicWidth + mnuTextBuffer) - 4
'Draw selected entry
  If DIS.itemState = ODS_SELECTED Then
     FillRect DIS.hdc, rct, hSelectedItem
  Else
     FillRect DIS.hdc, DIS.rcItem, hMenuColor
  End If
  PrintTrans IIf(DIS.itemState = ODS_SELECTED, crSelected, RGB(0, 0, 0))
  StretchBlt DIS.hdc, DIS.rcItem.Left + mnuEdgeWidth, DIS.rcItem.Top + mnuEdgeWidth, mnuPicWidth - mnuEdgeWidth, (DIS.rcItem.Bottom - DIS.rcItem.Top) - mnuEdgeWidth, m_Picture.hdc, 0, 0, m_Picture.ScaleWidth, m_Picture.ScaleHeight, SRCCOPY
  If DIS.itemState = ODS_SELECTED Then Draw3D
  DeleteObject hSelectedItem
  DeleteObject hMenuColor
End Sub

Private Sub Draw3D()
 'Init RECT
 Dim rct As RECT
   rct.Top = m_DIS.rcItem.Top
   rct.Left = m_DIS.rcItem.Left
   rct.Right = mnuPicWidth
   rct.Bottom = m_DIS.rcItem.Bottom
 'Draw edges
 Dim hpBlack As Long, hpWhite As Long
   hpWhite = CreatePen(PS_SOLID, mnuEdgeWidth, RGB(255, 255, 255)) '// White half of box
   hpBlack = CreatePen(PS_SOLID, mnuEdgeWidth, RGB(70, 70, 70))    '// Dark Grey half of box
   DeleteObject SelectObject(m_DIS.hdc, hpWhite)
   MoveToEx m_DIS.hdc, rct.Left + 1, (rct.Bottom - 1), 0
   LineTo m_DIS.hdc, rct.Left + 1, rct.Top + 1
   LineTo m_DIS.hdc, (rct.Right - 1), rct.Top + 1
   DeleteObject SelectObject(m_DIS.hdc, hpBlack)
   LineTo m_DIS.hdc, (rct.Right - 1), rct.Bottom - 1
   LineTo m_DIS.hdc, rct.Left + 1, rct.Bottom - 1
   DeleteObject hpWhite
   DeleteObject hpBlack
End Sub
