VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "COMCTL32.OCX"
Begin VB.Form Form1 
   Caption         =   "API Menus without subclassing"
   ClientHeight    =   4170
   ClientLeft      =   2925
   ClientTop       =   2760
   ClientWidth     =   5160
   LinkTopic       =   "Form1"
   ScaleHeight     =   4170
   ScaleWidth      =   5160
   Begin VB.CommandButton cmdRND 
      Caption         =   "&Random Tree"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   177
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   345
      Left            =   3870
      TabIndex        =   5
      Top             =   3780
      Width           =   1245
   End
   Begin ComctlLib.TreeView tvwItems 
      Height          =   3405
      Left            =   30
      TabIndex        =   1
      Top             =   300
      Width           =   5085
      _ExtentX        =   8969
      _ExtentY        =   6006
      _Version        =   327682
      Style           =   7
      Appearance      =   1
   End
   Begin VB.CommandButton cmdAddItem 
      Caption         =   "&Add Item"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   177
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   345
      Left            =   1290
      TabIndex        =   3
      Top             =   3780
      Width           =   1245
   End
   Begin VB.CommandButton cmdRemove 
      Caption         =   "Remove"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   177
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   345
      Left            =   2550
      TabIndex        =   4
      Top             =   3780
      Width           =   1245
   End
   Begin VB.CommandButton cmdAddSM 
      Caption         =   "&Add Submenu"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   177
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   345
      Left            =   30
      TabIndex        =   2
      Top             =   3780
      Width           =   1245
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Menu tree:"
      Height          =   195
      Left            =   60
      TabIndex        =   0
      Top             =   60
      Width           =   765
   End
   Begin VB.Menu mnuDummyPopUp 
      Caption         =   "DummyPopUp"
      Begin VB.Menu mnuDummy 
         Caption         =   "DummyItem"
         Index           =   0
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'*********************************************************************************************
'
' Run-Time API Menus without subclassing - 7/1999
'
' Main form
'
'*********************************************************************************************
'
' Author: Eduardo A. Morcillo
' E-Mail: edanmo@geocities.com
' Web Page: http://www.geocities.com/SiliconValley/Foothills/9940
'
' Last Updated: 07/08/1999
'
' Notes: This sample works only in VB 5.
'
'*********************************************************************************************

' Menu items count
Dim DummyCount As Long

Enum RenameOperations
    opItem
    opSubMenu
End Enum

Dim OP As RenameOperations


'*********************************************************************************************
' Adds a new submenu to hParentMenu
'*********************************************************************************************
'
' Parameters:
'
'    Caption:       The submenu caption
'    hParentMenu:   Handle to parent menu
'
' Returns:
'
'    Handle to the new submenu
'
'*********************************************************************************************
Private Function AddSubMenu(ByVal Caption As String, ByVal hParentMenu As Long) As Long
Dim ID As Long

    On Error Resume Next
    
    ' Load a new item
    Load mnuDummy(DummyCount)

    ' Create a new popup
    AddSubMenu = CreatePopupMenu()
    
    ' Add the popup menu to the hParentMenu
    AppendMenu hParentMenu, MF_POPUP, AddSubMenu, Caption
        
    ' Update menu bar
    DrawMenuBar Me.hwnd
    
    ' Store handle in Dummy Tag property
    mnuDummy(DummyCount).Tag = AddSubMenu
    
    DummyCount = DummyCount + 1
    
End Function


'*********************************************************************************************
' AddSubMenu: Add a new item to hParentMenu
'*********************************************************************************************
'
' Parameters:
'
'    Caption:       The item caption
'    hParentMenu:   Handle to parent menu
'
' Returns:
'
'    Dummy menu item index
'
'*********************************************************************************************
Private Function AddMenuItem(ByVal Caption As String, ByVal hParentMenu As Long) As Long
Dim ID As Long

    On Error Resume Next
    
    ' Load a new item
    Load mnuDummy(DummyCount)
    
    AddMenuItem = DummyCount

    ' We well use the dummy caption to
    ' store the parent menu handle
    mnuDummy(DummyCount).Caption = hParentMenu
        
    ' Here comes the trick:
    
    ' We get the command ID used for the new
    ' dummy item. Then we will use the same
    ' command id with the API created item.
    
    ID = GetCommand(mnuDummy(DummyCount))
    
    ' Store the ID in the dummy menu Tag
    mnuDummy(DummyCount).Tag = ID
    
    ' Add the item to the menu
    AppendMenu hParentMenu, MF_STRING Or MF_BYCOMMAND, ID, Caption
    
    ' Increment DummyCount
    DummyCount = DummyCount + 1
    
    ' Update menu bar
    DrawMenuBar Me.hwnd
     
End Function

Private Sub ClearAll()
Dim I As Long

    On Error Resume Next
    
    For I = 0 To DummyCount - 1
        
        ' Delete the menu
        DeleteMenu mnuDummy(I).Caption, mnuDummy(I).Tag, MF_BYCOMMAND
        
        ' Unload the dummy item
        Unload mnuDummy(I)
        
    Next
    
    DummyCount = 0

End Sub

Private Sub RemoveMenu(ByVal N As Node)

    DeleteMenu N.Parent.Tag, N.Tag, MF_BYCOMMAND
        
End Sub

Private Sub cmdAddItem_Click()
Dim ParentItem As Node, NewItem As Node

    With tvwItems
        
        ' Get parent node
        Set ParentItem = .SelectedItem
        
        ' Check is parent node is a
        ' a submenu
        
        If IsMenu(Val(ParentItem.Tag)) Then
            
            ' Add the new node
            
            Set NewItem = .Nodes.Add(ParentItem, tvwChild, , "New item")
            
            NewItem.EnsureVisible
            NewItem.Selected = True
            
            ' Set OP to use in
            ' tvwItems_AfterLabelEdit event
            OP = opItem
            
            ' Add the item to menu
            NewItem.Tag = AddMenuItem("New item", Val(ParentItem.Tag))
            
            ' Rename the item
            .StartLabelEdit
        
        Else
            
            Beep
            
        End If
                
    End With

End Sub

Private Sub cmdAddSM_Click()
Dim ParentItem As Node, NewItem As Node

    With tvwItems
        
        ' Get parent node
        Set ParentItem = .SelectedItem
        
        ' Check is parent node is a
        ' a submenu
        If IsMenu(Val(ParentItem.Tag)) Then
        
            ' Add the new node
            
            Set NewItem = .Nodes.Add(ParentItem, tvwChild, , "New menu")
        
            NewItem.EnsureVisible
            NewItem.Selected = True
            
            ' Set OP to use in
            ' tvwItems_AfterLabelEdit event
            OP = 1
            
            ' Add the submenu to menu
            NewItem.Tag = AddSubMenu("New menu", Val(ParentItem.Tag))
            
            ' Rename the item
            .StartLabelEdit
        
        Else
            
            Beep
            
        End If
        
    End With
    
End Sub

Private Sub cmdRemove_Click()

    With tvwItems
        
        If .SelectedItem.Index <> 1 Then
            
            RemoveMenu .SelectedItem
            
            .Nodes.Remove .SelectedItem.Index
            
        End If
        
    End With
    

End Sub

Private Sub cmdRND_Click()
Dim I As Integer, SM As Long, N As Node

    ClearAll
    
    tvwItems.Nodes.Clear
    
    SM = GetMenu(Me.hwnd)
    Set N = tvwItems.Nodes.Add(, , , "MenuBar")
    
    For I = 1 To 40
        
        If Rnd > 0.7 Then
            SM = AddSubMenu("Submenu " & I, SM)
            Set N = tvwItems.Nodes.Add(N, tvwChild, , "Submenu " & I)
        ElseIf Rnd > 0.8 Then
            SM = GetMenu(Me.hwnd)
            Set N = tvwItems.Nodes(1)
        End If
        
        AddMenuItem "Item " & I, SM
        tvwItems.Nodes.Add N, tvwChild, , "Item " & I
        
    Next
    
    tvwItems.Nodes(1).Expanded = True
End Sub

Private Sub Form_Load()

    Randomize Timer
    
    tvwItems.Nodes.Add , , , "Menu Bar"
    tvwItems.Nodes(1).Tag = CStr(GetMenu(Me.hwnd))
    
    mnuDummyPopUp.Visible = False
    
End Sub

Private Sub Form_Unload(Cancel As Integer)

    ClearAll
    
End Sub

Private Sub mnuDummy_Click(Index As Integer)

    MsgBox "You click on " & mnuDummy(Index).Caption
    
End Sub

Private Sub tvwItems_AfterLabelEdit(Cancel As Integer, NewString As String)
Dim hMenu As Long

    With tvwItems.SelectedItem
    
        hMenu = Val(.Parent.Tag)
    
        Select Case OP
            Case opSubMenu
                
                ' Modify submenu name
                ModifyMenu hMenu, .Tag, MF_POPUP, .Tag, NewString
                
            Case opItem
                
                ' Modify item name
                ModifyMenu hMenu, mnuDummy(.Tag).Tag, MF_BYCOMMAND, mnuDummy(.Tag).Tag, NewString
                
        End Select
    
    End With
    
    DrawMenuBar Me.hwnd
    
End Sub

